' Bestimme Weite eines Textes.

' Eine Beschreibung dieser Prozedur befindet sich in QTxtWeit.prf
' Version 2.3  18.5.2003.      Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka
'                       email: g.putschalka@web.de
'                    homepage: http://members.telering.at/g.putschalka/index.html

Def @GetWeite(4) ! "GDI32","GetTextExtentPoint32A"
' Lnge eines Textes bestimmen. Par.1 = Text$ (Stringvariable),
'                               Par2 = 0 oder 1. 0 = fr Bildschirmausgabe
'                                                1 = fr die Ausgabe an den Drucker.
' Fr die Ausgabe zum Drucker wird die Lnge durch 10 dividiert.

' der zu prfende Text mu in der Stringvariablen (Parameter 1) stehen.
' Rckgabe: Lnge des Textes als LongInteger
Proc TextWeite
  Parameters T$,Prt_Ctl%
  Declare Z$,Adr&,Adr1&,Leng&
  Let Z$ = "000000"    ' wichtig ab Profan 7.x !
  Let Adr&=@If(@LT$(@Left$($PROFVER,1),"7"),@Add(@Addr(T$),1),@Addr(T$))
  Let Adr1&=@If(@LT$(@Left$($PROFVER,1),"7"),@Add(@Addr(Z$),1),@Addr(Z$))
  @GetWeite(%HDC,Adr&,@Len(T$),Adr1&)
  Let Leng&=@Long(Adr1&,0)
  Let Leng&=@If(@Equ(Prt_Ctl%,1),(@Long(Adr1&,0)/10),@Long(Adr1&,0))
  Return Leng&
EndProc
